unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Windows, cTypes, libOpenSSL_3;//, libOpenSSL_1;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    memData: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.frm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  memData.CLear;
  if (not libSSL3_Load) then begin
    Application.Terminate;
  end;
  if (not libCrypto3_Load) then begin
    Application.Terminate;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
	libCrypto3_Free;
  libSSL3_Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
const
  intKeySize = 2048;
var
  mem					:	TMemoryStream;
  bye					:	TByte;
  _rsa      	: pRSA;
  _bio      	: pBIO;
  intRet    	: CInt;
  _BIO_METHOD	:	PBIO_METHOD;
begin
  try
    try
      memData.Lines.Add('Generate Start.');
      _rsa := RSA_generate_key(intKeySize, 65537, nil, nil);
      if (_rsa = nil) then begin
        memData.Lines.Add('Error generate key.');
        exit;
      end;
      memData.Lines.Add('Generate End.');

      memData.Lines.Add('BIO new Start.');
      //_bio := BIO_new(BIO_s_mem());
      _bio := BIO_new(_BIO_METHOD);
      if (_bio = nil) then begin
        memData.Lines.Add('Error create memory space.');
        exit;
      end;
      memData.Lines.Add('BIO new End.');

      memData.Lines.Add('PEM write bio RSA PubKey Start.');
      try
        intRet := PEM_write_bio_RSAPublicKey(_bio, _rsa);
        if intRet <= 0 then begin
          memData.Lines.Add('Error Public key to PEM.');
          memData.Lines.Add(GetLastError.ToString + ' ' + SysErrorMessage(GetLastError));
          exit;
        end;
        memData.Lines.Add('PEM write bio RSA PubKey End.');
      finally
        if (_bio <> nil) then BIO_free(_bio);
      end;
    finally
      if (_Rsa <> nil) then RSA_Free(_Rsa);
    end;
  except
    on E : Exception do begin
      memData.Lines.Add(E.Message);
    end;
  end;
end;

end.

